﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamGridUnboundColumn
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            ObservableCollection<Person> persons = new ObservableCollection<Person>();
            persons.Add(new Person("Hans", "Rosenthal"));
            persons.Add(new Person("Robert", "Mayer"));
            persons.Add(new Person("Daniel", "Mayer"));
            persons.Add(new Person("Christian", "Mayer"));
            persons.Add(new Person("Hans", "Bauer"));
            persons.Add(new Person("Kai", "Rosenthal"));
            persons.Add(new Person("Helmut", "Bauer"));
            persons.Add(new Person("Jürgen", "Huber"));
            persons.Add(new Person("Thomas", "Rosenthal"));
            persons.Add(new Person("Julia", "Bauer"));
            persons.Add(new Person("Kerstin", "Huber"));
            this.xamGrid1.ItemsSource = persons;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private string _name;
        public string Name 
        {
            get { return _name; } 
            set 
            {
                if (_name != value)
                {
                    _name = value;
                    OnPropertyChanged("Name");
                }
            } 
        }

        private string _surname;
        public string Surname 
        {
            get { return _surname; }
            set
            {
                if (_surname != value)
                {
                    _surname = value;
                    OnPropertyChanged("Surname");
                }
            }  
        }

        public Person()
        { }

        public Person(string name, string surname)
        {
            Name = name;
            Surname = surname;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
